<?php
// SNE Ver1.28.3 ～ 1.29.05α用ログから該当地震IDのデータを読み込みhtmlで返す

include_once("config.phps");
header("Content-Type: text/html;charset=UTF-8");

if(file_exists(__SNE_LOG)){
	$sne_connect = -1;
	$past_view = 0;
	$eId = "";
	$geId = "";
	if(@$_GET['eId']){
		$eId = $_GET['eId'];
	} else if(@$_POST['eId']){
		$eId = $_POST['eId'];
//		echo var_dump($_POST);
	}

	$line = file(__SNE_LOG);

	$str_target = "";
	if($eId == ""){
		$canId = "-----------------------";
		for($i=count($line)-1;$i>0;$i--){
			if((mb_ereg("過去の地震を",$line[$i]) || mb_ereg("System.BadImageFormatException:",$line[$i])) && $sne_connect == -1){
				$past_view = 1;
				break;
			} else if(mb_ereg(": 情報:",$line[$i]) && $past_view == 0){
				if(mb_ereg("通信を開始",$line[$i])){
					$sne_connect = 1;
				} else {
					$sne_connect = 0;
				}
				break;
			} else if(mb_ereg("データ受信",$line[$i]) && !mb_ereg($canId,$line[$i])){
				if($i < count($line) && mb_ereg("///////////////////", $line[$i])){		// キャンセル報を除外
					$array1 = explode("ND",$line[$i]);
//					$array1 = explode("地震ID=",$line[$i+1]);
//					$array2 = explode("(",$array1[1]);
//					$canId = $array2[0];
					$canId = "ND" . substr($array1[1],0,14);
//					print("// " . $canId . "\n");
				} else if($i < count($line) + 1 && !mb_ereg("震央距離異常地震",$line[$i+1])){	// その他の異常を除外
					$str_target = $line[$i+1];
					$content = mb_split(" : データ受信",$line[$i]);
					$str_data = trim($content[1]);
					break;
				}
			}
		}
	} else {
		for($i=count($line)-1;$i>0;$i--){
			if((mb_ereg("過去の地震を",$line[$i]) || mb_ereg("System.BadImageFormatException:",$line[$i])) && $sne_connect == -1){
				$past_view = 1;
				break;
			} else if(mb_ereg(": 情報:",$line[$i]) && $past_view == 0){
				if(mb_ereg("通信を開始",$line[$i])){
					$sne_connect = 1;
				} else {
					$sne_connect = 0;
				}
				break;
			} else if(mb_ereg("データ受信",$line[$i]) && mb_ereg($eId,$line[$i])){
				if(mb_ereg("///////////////////", $line[$i])){
					$str = mb_substr($line[$i],0,19);
					$str = str_replace("/","-",$str);
					exit("<span class='num small' id='d_mag'>$str</span> <span id='cancel'>キャンセル報を受信</span><span id='last' style='display:none'></span>");
				} else if(mb_ereg($eId,$line[$i+1]) && !mb_ereg("震央距離異常地震",$line[$i+1])){
					$str_target = $line[$i+1];
					$content = mb_split(" : データ受信",$line[$i]);
					$str_data = trim($content[1]);
					break;
				}
			}
		}
	}
//	print("// " . $str_target . "\n");
	if($str_target != ""){
		if(mb_ereg("（震源の深さが150km以上）",$str_target)){
			$str_target = mb_ereg_replace("（震源の深さが150km以上）", ",",$str_target);
		}
		$item = mb_split(",",$str_target);

		for($j=0;$j<count($item);$j++){
			$content = mb_split("=",$item[$j]);
			switch($content[0]){
				case "地震ID":
					$num = strpos($content[1],"(");
					$ver = substr($content[1], $num + 1, strlen($content[1]) - $num - 2);
					$array = explode("(",$content[1]);
					$geId = $array[0];
					break;

				case "地震発生時刻":
					$etime = strtotime($content[1]);
					break;

				case "震源地緯度/経度":
					$arrT = explode("/",$content[1]);
					$eLat = $arrT[0];
					$eLng = $arrT[1];
					break;

				case "観測地緯度/経度":
					$arrT = explode("/",$content[1]);
					$hLat = $arrT[0];
					$hLng = $arrT[1];
					break;

				case "マグニチュード":
					$mag = $content[1];
					if(strlen($mag . "") == 1) $mag .= ".0";
					break;

				case "震源の深さ":
					$depth = str_replace(".0","",$content[1]);
					break;

				case "震度":
					$level = round($content[1],1);
					if(strlen($level . "") == 1) $level .= ".0";
					break;

				case "S波到達秒数":
					$stime = trim($content[1]);
					break;

				case "震央の確からしさフラグ":
					$p_num1 = $content[1];
					break;

				case "震源の深さの確からしさフラグ":
					$p_num2 = $content[1];
					break;

				case "マグニチュードの確からしさフラグ":
					$p_num3 = $content[1];
					break;
			}
		}
		if(@isset($p_num1)){
			$accu = pow(2,min($p_num1,6)) + pow(2,min($p_num2,6)) + pow(2,min($p_num3,6));
		} else {
			$p_num1 = substr($str_data,65,1);
			$p_num2 = substr($str_data,66,1);
			$p_num3 = substr($str_data,67,1);
			$accu = pow(2,min($p_num1,6)) + pow(2,min($p_num2,6)) + pow(2,min($p_num3,6));
		}
		if(strlen($str_data) >= 70){
			$areas = array();
			for ($k=70; $k<strlen($str_data); $k += 3) {
				$areas[] = substr($str_data,$k,3);
			}
		}

		$last = 0;
		if($eId != ""){
			$check = explode($eId,$str_data);
			if(substr($check[1],0,1) == "9"){
				$last = 1;
			}
		}
		if($geId != ""){
			$check = explode($geId,$str_data);
			if(substr($check[1],0,1) == "9"){
				$last = 1;
			}
		}
		if($last == 1){
			print("<span id='last' style='display:none'>&nbsp;</span>\n");
		}
		print("暫定Mj:<span class='num small' id='mag'>$mag</span>　深さ:<span class='num small' id='depth'>$depth</span>km　");
		print("予想震度：<span class='num small' id='level'>$level</span>　");
		if($last){
			print("<span class='ver'>(最終報)</span>\n");
		} else {
			print("<span class='ver'>(第" . $ver . "報)</span>\n");
		}
		print("<div style='display:none' id='data'>\n");
		if($sne_connect == 0){
			$res = exec('tasklist.exe /fi "imagename eq SignalNowExpress.exe"',$result,$return);
			if(mb_ereg("SignalNowExpress.exe", $res)){
				print("<span id='d_sne_connect'>接続エラー</span>");
			} else {
				print("<span id='d_sne_exec'>起動エラー</span>");
			}
		}
		if($past_view == 1){
			print("<span id='d_past'></span>\n");
		}
		print("<span id='d_eId'>$geId</span>\n");
		print("<span id='d_ver'>$ver</span>\n");
		print("<span id='d_etime'>$etime</span>\n");
		print("<span id='d_eLat'>$eLat</span>\n");
		print("<span id='d_eLng'>$eLng</span>\n");
		print("<span id='d_hLat'>$hLat</span>\n");
		print("<span id='d_hLng'>$hLng</span>\n");
		print("<span id='d_mag'>$mag</span>\n");
		print("<span id='d_depth'>$depth</span>\n");
		print("<span id='d_level'>$level</span>\n");
		print("<span id='d_stime'>$stime</span>\n");
		print("<span id='d_accu'>" . $accu . "/192</span>\n");
		if(count($areas)>0){
			print("<span id='d_area'>" . join(",",$areas) . "</span>;\n");
		}
		print("</div>\n");
	} else {
		if($past_view == 1){
			print("<span id='d_past'></span>\n");
		} else if($sne_connect == 0){
			$res = exec('tasklist.exe /fi "imagename eq SignalNowExpress.exe"',$result,$return);
			if(mb_ereg("SignalNowExpress.exe", $res)){
				print("<span id='d_sne_connect'>接続エラー</span>");
			} else {
				print("<span id='d_sne_exec'>起動エラー</span>");
			}
		} else if($sne_connect == -1){
			print("<span id='error'>ログデータエラー</span>");
		}
	}
} else {
	if(@isset($eId) && $eId == ""){
		print("1,0,0");
	} else {
		print("<span id='error'>ログファイルエラー</span>");
		print(get_current_user());
	}
}
?>
