Number.prototype.toRad = function(){
	return this * Math.PI / 180;
}
google.maps.LatLng.prototype.distanceFrom = function(position){
	var lat1 = this.lat();
	var lon1 = this.lng();
	var lat2 = position.lat();
	var lon2 = position.lng();
	var R = 6371;
	var dLat = (lat2 - lat1).toRad();
	var dLon = (lon2 - lon1).toRad();
	lat1 = lat1.toRad();
	lat2 = lat2.toRad();
	var a = Math.sin(dLat / 2) * Math.sin(dLat / 2) +
		Math.cos(lat1) * Math.cos(lat2) *
		Math.sin(dLon / 2) * Math.sin(dLon / 2);
	var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
	var d = R * c;
	return d.toFixed(1);
}
<?php
include_once("config.phps");
if(@$_GET['test'] == "1"){
	$test = true;
	print("var test = 1;\n");
} else {
	$test = false;
	print("var test = 0;\n");
}
if(@$_GET['pop']){
	print("var pop = 1;\n");
} else {
	print("var pop = 0;\n");
}
if($show_nied){
	print("var nied = 1;\n");
} else {
	print("var nied = 0;\n");
}
$sne_connect = 1;
if(file_exists(__SNE_LOG)){
	(@$_GET['eId'])? $eId = $_GET['eId'] : $eId = "0";

	if(@$_GET['eId']){
		$line = file(__SNE_LOG);
	} else {
		if(defined("__PAST_LOG") && file_exists(__PAST_LOG)){	// 過去ログ処理
			$line1 = file(__PAST_LOG);
		}
		$line2 = file(__SNE_LOG);
		if(isset($line1)){
			$line = array_merge($line1,$line2);
		} else {
			$line = $line2;
		}
	}
	if($test && $eId != 0){															// 各地震のデータをjsの変数として渡す
		include("get_js.phps");
	}
	if($test && @$_GET['eId'] && @$_GET['dotest'] && $_GET['dotest'] == "1"){		// テストモード 再生時
		print("var eCase = 8;\n");
		print("var now = 0;\n");
		print("var ver = 0;\n");
		print("var eId = \"" . $_GET['eId'] . "\";\n");
		print("var centerPos = new google.maps.LatLng(36.633162,138.383789);\n");
		print("var epiPos = new google.maps.LatLng(0,0);\n");
		print("var distance;\n");
		print("var etime;\n");
		print("var mag;\n");
		print("var depth;\n");
		print("var level;\n");
		print("var stime;\n");
		print("var last = 0;\n");
		print("var sne_exec = 1;\n");
		print("var sne_connect = 1;\n");
		print("var pre_level = -1;\n");
		print("var accu = '';\n");
		print("var areas = new Array();\n");
	} else if($test){																	// テストモード リスト
		print("var eCase = 9;\n");
		print("var centerPos = new google.maps.LatLng(36.633162,138.383789);\n");
		print("var distance = 1500;\n");
		print("var epiPos = new google.maps.LatLng(36.710394,-6.033404);\n");
		print("var homePos = new google.maps.LatLng(50.946543,4.071789);\n");
		print("var level = 0;\n");
		print("var sne_exec = 1;\n");
		print("var sne_connect = 1;\n");
		print("var pre_level = -1;\n");
		print("var eId = \"\";\n");
		print("var accu = '';\n");
/*
		print("var etime;\n");
		print("var last = 0;\n");
		print("var ver = 0;\n");
		print("var mag;\n");
		print("var depth;\n");
		print("var level;\n");
		print("var stime;\n");
*/
	} else {
		if(@$_GET['eId']){
			for($i=count($line)-1;$i>0;$i--){
//				if(mb_ereg("地震情報",$line[$i])){
				if(mb_ereg("データ受信",$line[$i])){
					$content = mb_split(" : データ受信",$line[$i]);
					$str_data = trim($content[1]);

					if(mb_ereg($_GET['eId'],$line[$i])){
						print("var eCase = 3;\n");											// 同一地震
						if(@$_GET['level']){
							print("var pre_level = " . $_GET['level'] . ";\n");
						} else {
							print("var pre_level = 0;");
						}
					} else {																// 後発地震有り
						$item = mb_split(",",$line[$i+1]);
						$new_level = 0;
						for($j=0;$j<count($item);$j++){
							$content = mb_split("=",$item[$j]);
							if($content[0] == "震度"){
								if(@$_GET['level'] && $content[1] < $_GET['level']){		// 後発地震の予想震度が現在の地震より下回ったら
									$new_level = $content[1];
									print("var eCase = 3;\n");								// 同一地震優先
									print("var pre_level = " . $_GET['level'] . ";\n");
									break;
								}
							}
						}
						if($new_level == 0){
							print("var eCase = 10;\n");										// 後発地震
							print("var pre_level = -1;\n");
						}
					}
					if(mb_ereg("地震表示",$line[$i+1])){
						$str_target = $line[$i+2];
					} else {
						$str_target = $line[$i+1];
					}
//					$line_target = $i - 1;
					break;
				}
			}
			print("var sne_exec = 1;\n");
			print("var sne_connect = 1;\n");
		} else {
			
			
			include("read_log.phps");
		}
//		print("// \$i = "  . $i . "\n");
		if($i <= 0){						// ログファイルに地震履歴無し
			

			print("var eCase = 98;\n");
			print("var centerPos = new google.maps.LatLng(36.633162,138.383789);\n");
			print("var distance = 1500;\n");
			print("var epiPos = new google.maps.LatLng(36.710394,-6.033404);\n");
			print("var homePos = new google.maps.LatLng(50.946543,4.071789);\n");
			print("var level = 0;\n");
			print("var last = 0;\n");
			print("var ver = 0;\n");
			print("var pre_level = -1;\n");
		} else {
			if(mb_ereg("（震源の深さが150km以上）",$str_target)){
				$str_target = mb_ereg_replace("（震源の深さが150km以上）", ",",$str_target);
			}
			$item = mb_split(",",$str_target);
			print("var now = 0;\n");
			for($j=0;$j<count($item);$j++){
				$content = mb_split("=",$item[$j]);
				switch($content[0]){
					case "地震ID":
						$num = strpos($content[1],"(");
						$eId = substr($content[1],0,$num);
						print("var eId = \"" . $eId . "\";\n");
						$ver = substr($content[1], $num + 1, strlen($content[1]) - $num - 2);
						print("var ver = \"" . $ver . "\";\n");
						break;
					case "地震発生時刻":
						print("var etime = " . strtotime($content[1]) . ";\n");
						break;
					case "震源地緯度/経度":
						$value = split("/",$content[1]);
						print("var epiPos = new google.maps.LatLng(" . str_replace("/",", ",$content[1]) . ");\n");
						$eLat = $value[0];
						$eLng = $value[1];
						break;
					case "観測地緯度/経度":
						$value = split("/",$content[1]);
						print("var homePos = new google.maps.LatLng(" . str_replace("/",", ",$content[1]) . ");\n");
						$value = split("/",$content[1]);
						$cLat = $value[0];
						$cLng = $value[1];
						break;
					case "マグニチュード":
						$mag = $content[1];
						if(strlen($mag . "") == 1) $mag .= ".0";
						print("var mag = " . $mag . ";\n");
						break;
					case "震源の深さ":
						$depth = str_replace(".0", "", $content[1]);
						print("var depth = " . $depth . ";\n");
						break;
					case "震度":
						$level = round($content[1],1);
						if(strlen($level . "") == 1) $level .= ".0";
						print("var level = " . $level . ";\n");
						break;
					case "S波到達秒数":
						print("var stime = " . trim($content[1]) . ";\n");
						break;

					case "震央の確からしさフラグ":
						$p_num1 = $content[1];
						break;

					case "震源の深さの確からしさフラグ":
						$p_num2 = $content[1];
						break;

					case "マグニチュードの確からしさフラグ":
						$p_num3 = $content[1];
						break;
				}
			}
			if(isset($p_num1)){
				$accu = pow(2,min($p_num1,6)) + pow(2,min($p_num2,6)) + pow(2,min($p_num3,6));
				print("var accu = '" . $accu . "/192';\n");
			} else {
				$p_num1 = substr($str_data,65,1);
				$p_num2 = substr($str_data,66,1);
				$p_num3 = substr($str_data,67,1);
				$accu = pow(2,min($p_num1,6)) + pow(2,min($p_num2,6)) + pow(2,min($p_num3,6));
				print("var accu = '" . $accu . "/192';\n");
//				print("var accu = '';\n");
			}
			if(strlen($str_data) >= 70){
				$areas = array();
				for ($k=70; $k<strlen($str_data); $k += 3) {
					$areas[] = substr($str_data,$k,3);
				}
				print("var areas = \"" . join(",",$areas) . "\";\n");
			}

			$midLat = ($eLat + $cLat) / 2;
			$midLng = ($eLng + $cLng) / 2;
			print("var centerPos = new google.maps.LatLng(" . $midLat . ", " . $midLng . ");\n");
			if(ereg($eId,$str_data)){
				$check = explode($eId, $str_data);
				if(substr($check[1],0,1) == "9"){
					print("var last = 1;\n");
				} else {
					print("var last = 0;\n");
				}
			} else {
				print("var last = 0;\n");
			}
			print("var distance = epiPos.distanceFrom(homePos);\n");
		}
	}
} else {		// 該当ログファイル無し
	print("var eCase = 99;\n");
	print("var centerPos = new google.maps.LatLng(36.633162,138.383789);\n");
	print("var distance = 1500;\n");
	print("var epiPos = new google.maps.LatLng(36.710394,-6.033404);\n");
	print("var homePos = new google.maps.LatLng(50.946543,4.071789);\n");
	print("var level = 0;\n");
	print("var eId = \"\";\n");
}
print("var s_width = 740;\n");
print("var s_height = 640;\n");
print("var m_width = 1024;\n");
print("var m_height = 768;\n");
print("var m_max = 1;\n");
print("var sne_connect = " . $sne_connect . ";\n");
print("var __MP3_DIR = '" . __MP3_DIR . "';\n");
print("var __OGG_DIR = '" . __OGG_DIR . "';\n");
print("var __WAV_DIR = '" . __WAV_DIR . "';\n");
print("var __IMG_DIR = '" . __IMG_DIR . "';\n");
print("var __SELF_DIR = '" . __SELF_DIR . "';\n");
print("var __SERVER_URL = '" . __SERVER_URL . "';\n");
?>
